#!/usr/bin/python

from Adafruit_CharLCD import Adafruit_CharLCD
from subprocess import * 
from time import sleep, strftime
from datetime import datetime
import sys
import os
import errno
from daemon import Daemon
import syslog

pipe_name = '/tmp/lcddisplay.fifo'


def safe_read(fd, size=1024):
  ''' reads data from a pipe and returns `None` on EAGAIN '''
  try:
    return os.read(fd, size)
  except OSError as exc:
    if exc.errno == errno.EAGAIN:
      return None
    raise


def run_cmd(cmd):
        p = Popen(cmd, shell=True, stdout=PIPE)
        output = p.communicate()[0]
        return output


class MyDaemon(Daemon):
	def run(self):
		syslog.openlog(ident="lcddisplay",logoption=syslog.LOG_PID, facility=syslog.LOG_LOCAL0)
		syslog.syslog('lcddisplay started...')

		if os.access(pipe_name, os.F_OK):
                  os.unlink(pipe_name)
                os.mkfifo(pipe_name)
                pipein = os.open( pipe_name, os.O_RDONLY | os.O_NONBLOCK )

                lcd = Adafruit_CharLCD()

                lcd.begin(20,4)

                lcd.clear()

                while 1:

                  #lcd.clear()
                  #lcd.setCursor(1,0)
                  #lcd.message(datetime.now().strftime('%H:%M'))

                  line=safe_read(pipein)
                  if line:
                    lineparts=line.split("\n")
                    line0=lineparts[0][0:19]
                    line0+=" "*(20-len(line0))
                    lcd.setCursor(0,0)
                    lcd.message(line0)
                    line1=lineparts[1][0:19]
                    line1+=" "*(20-len(line1))
                    lcd.setCursor(0,1)
                    lcd.message(line1)
                    line2=lineparts[1][20:39]
                    line2+=" "*(20-len(line2))
                    lcd.setCursor(0,2)
                    lcd.message(line2)
                    line3=lineparts[1][40:59]
                    line3+=" "*(20-len(line3))
                    lcd.setCursor(0,3)
                    lcd.message(line3)

                  sleep(0.1)


		syslog.syslog('lcddisplay stopped...')

if __name__ == "__main__":
	daemon = MyDaemon('/tmp/lcddisplay.pid')
	if len(sys.argv) == 2:
		if 'start' == sys.argv[1]:
			daemon.start()
		elif 'stop' == sys.argv[1]:
			daemon.stop()
		elif 'restart' == sys.argv[1]:
			daemon.restart()
		else:
			print "Unknown command"
			sys.exit(2)
		sys.exit(0)
	else:
		print "usage: %s start|stop|restart" % sys.argv[0]
		sys.exit(2)
